#include "Termstr.h"              // библиотека датчика Termistr
#include <MsTimer2.h>
#include <Led4Digits.h>
#include <Button.h>    // библиотека класса TButton
#include <Led.h>       // библиотека клааса TLed
#include <EEPROM.h>      

#define THERMISTOR_PIN        A0      // пин, к которому подключен термистор
#define RELE_PIN A1 // кнопка1
#define BUTTON_1_PIN A2 // кнопка1
#define BUTTON_2_PIN A3 // кнопка2
#define BUTTON_3_PIN A4 // кнопка3
#define MEASURE_COUNT        500      // количество считываний с пинов для усреднения (период усредненного измерения = MEASURE_COUNT * PIN_MEASURE_PERIOD) 


Led4Digits disp(2, 4,5,3,2, 6,7,8,9,10,11,12,13);

// для термистора
#define TERMISTOR_SERIES_RESISTOR  10000 // сопротивление второго резистора в цепи с термистором
#define TERMISTOR_NOMINAL_RESISTOR 10000  // номинальное сопротивление термистора при номинальной температуре
#define TERMISTOR_NOMINAL_TEMP     25    // номинальная температура
#define TERMISTOR_B_COFF           3950  // B-коэффициент термистора     

int temp;
byte LimitTemp;
byte mode = 1;
byte Rele_Period = 2;
boolean CoolHot = 0; // 0 - Cool 1 - Hot

TTermstr Termistor(THERMISTOR_PIN, MEASURE_COUNT); // объявление термистора
TButton modeButton(BUTTON_1_PIN, 30); // объект кнопка
TButton plusButton(BUTTON_2_PIN, 30); // объект кнопка
TButton minusButton(BUTTON_3_PIN, 30); // объект кнопка
TLed    Rele1(RELE_PIN, false);     // Реле
void setup() 
{
  // put your setup code here, to run once:
  MsTimer2::set(2, timerInterrupt); // прерывание по таймеру 2 мс
  MsTimer2::start();               // разрешение прерывания
  Serial.begin(9600);
  LimitTemp = EEPROM.read(1);
  CoolHot = EEPROM.read(0);
}

void loop() 
{
  temp = Termistor.Measure(TERMISTOR_SERIES_RESISTOR, TERMISTOR_NOMINAL_TEMP, TERMISTOR_NOMINAL_RESISTOR, TERMISTOR_B_COFF);

  Serial.print("mode = ");  Serial.println(mode);
  Serial.print("temp = ");  Serial.println(temp);
   

  if(mode == 1) // Рабочий режим - показ температуры, контроль температуры
  {
    disp.print(temp, 3, 1); // вывести число
    Serial.println(temp);
    
    if(modeButton.getClick())  // нажали кнопку 
    {  Serial.println("Click");
       mode = 2;
    }
  if(temp != SENSOR_NULL)
 {Serial.println("Sensor!");
  if(CoolHot) // 1
    {  if(temp <= LimitTemp)
        Rele1.On();
      if(temp >= LimitTemp + Rele_Period)
        Rele1.Off();
   }
   else // 0
   { if(temp >= LimitTemp)
       Rele1.On();
     if(temp <= LimitTemp - Rele_Period)
       Rele1.Off();
   }
  }} // if(mode == 1) // Рабочий режим - показ температуры, контроль температуры
  
  if(mode == 2)// Настройка лимита температуры
  { 
      disp.digit[2]= B10000000; // гашение знака
    if(modeButton.getClick())  // нажали кнопку 
      mode = 3;
  
     SetLimitTemp();
  }

   if(mode == 3)
   {
//     disp.digit[0]= B00000000; // гашение знака
//     disp.digit[1]= B00000000; // гашение знака
     disp.tetradToSegCod(3, CoolHot);
      if(plusButton.getClick()||minusButton.getClick())  // нажали кнопку 
       CoolHot = !CoolHot;
       EEPROM.write(0, CoolHot);
       if(modeButton.getClick())  // нажали кнопку 
       { 
        disp.digit[3]= B00000000; // гашение знака
        disp.digit[2]= B00000000; // гашение знака
        mode = 1;
       }
    }
 } // loop() 

void SetLimitTemp()
{
  disp.print(LimitTemp, 3, 1); // вывести число
   if(plusButton.getClick())  // нажали кнопку 
     LimitTemp++;
   if(minusButton.getClick())  // нажали кнопку 
     LimitTemp--;
   EEPROM.write(1, LimitTemp);
   if(modeButton.getClick())  // нажали кнопку 
  {   
    mode = 1;
    
  }
   if(LimitTemp == 255) 
    LimitTemp = 0;
 }

 

// обработчик прерывания 2 мс
void  timerInterrupt()
{
  disp.regen(); // регенерация индикатора
  modeButton.scanState();
  plusButton.scanState();
  minusButton.scanState();
  Termistor.scanState();
  Rele1.scanState();
}
